//
//  AppDelegate.m
//  Background Changer
//
//  Created by Shaheen Ghiassy on 8/14/13.
//  Copyright (c) 2013 Shaheen Ghiassy. All rights reserved.
//

#import "AppDelegate.h"
#import "FeedNavController.h"
#import "FeedTableViewController.h"
#import "FavoritiesViewController.h"
#import "ProfileNavController.h"

@implementation AppDelegate

// Override point for customization after application launch.
- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    NSLog(@"Hello World - Application Starting Up");
    
    //Create view Controllers
    ProfileNavController *profileNavController = [[ProfileNavController alloc] init];
    FeedNavController *feedNavController = [[FeedNavController alloc] init];
    FavoritiesViewController *favoritesViewController = [[FavoritiesViewController alloc] init];
    
    //Create tab bar Controllers
    UITabBarController *tabBarController = [[UITabBarController alloc] init];
    [tabBarController setViewControllers:@[feedNavController, favoritesViewController, profileNavController]];

    //Set up windows and make visible
    self.window = [[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]];
    self.window.rootViewController = tabBarController;
    [self.window makeKeyAndVisible]; //Means it should recieve all keyboard and non-touch events

    return YES;
}
							
- (void)applicationWillResignActive:(UIApplication *)application
{
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

@end
