//
//  FeedTableViewController.m
//  Background Changer
//
//  Created by Shaheen Ghiassy on 8/15/13.
//  Copyright (c) 2013 Shaheen Ghiassy. All rights reserved.
//

#import "FeedTableViewController.h"
#import "PhotoViewController.h"
#import "AFJSONRequestOperation.h"
#import "UIImageView+AFNetworking.h"
#import "PhotoModel.h"

@interface FeedTableViewController ()

@end

@implementation FeedTableViewController

- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
        self.tabBarItem.image = [UIImage imageNamed:@"feed.png"];
        self.tabBarItem.title = @"Feed";
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];

    // Uncomment the following line to preserve selection between presentations.
    // self.clearsSelectionOnViewWillAppear = NO;
 
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
    
    //Send a Network Request for Information
    NSURL *url = [[NSURL alloc] initWithString:@"https://ajax.googleapis.com/ajax/services/search/images?v=1.0&q=funky%20monkey"];
    NSURLRequest *request = [[NSURLRequest alloc] initWithURL:url];
    AFJSONRequestOperation *operation = [AFJSONRequestOperation JSONRequestOperationWithRequest:request
                                                                                        success:^(NSURLRequest *request, NSHTTPURLResponse *response, id JSON) {
                                                                                            NSLog(@"Request Google Image Search Successfull");
                                                                                            
                                                                                            //Iterate through JSON response and create a NSArray of Photo objects
                                                                                            NSMutableArray *tempArray = [[NSMutableArray alloc] init];
                                                                                            for(NSDictionary *dict in JSON[@"responseData"][@"results"]) {
                                                                                                PhotoModel *photo = [[PhotoModel alloc] initWithPhotoId:dict[@"imageId"]
                                                                                                                                          url:dict[@"url"]
                                                                                                                                        title:dict[@"titleNoFormatting"]
                                                                                                                                      content:dict[@"contentNoFormatting"]];
                                                                                                [tempArray addObject:photo];
                                                                                            }
                                                                                            
                                                                                            self.photos = [[NSArray alloc] initWithArray:tempArray];
                                                                                            
                                                                                            [self.tableView reloadData];
                                                                                        } failure:^(NSURLRequest *request, NSHTTPURLResponse *response, NSError *error, id JSON) {
                                                                                            NSLog(@"Network Request Error %@", error.localizedDescription);
                                                                                        }];
    [operation start];
    
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return self.photos.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"Cell"];
    
    // Configure the cell...
    if(cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:@"title"];
        cell.textLabel.text = [self.photos[indexPath.row] title];
        [cell.imageView setImageWithURL:[NSURL URLWithString:[self.photos[indexPath.row] URL]] placeholderImage:[UIImage imageNamed:@"loader.gif"]];
    }
    
    return cell;
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:@[indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    PhotoViewController *photoViewController = [[PhotoViewController alloc] init];
    photoViewController.photo = self.photos[indexPath.row];
    [self.navigationController pushViewController:photoViewController animated:YES];
}

@end
