//
//  User.m
//  Background Changer
//
//  Created by Shaheen Ghiassy on 8/16/13.
//  Copyright (c) 2013 Shaheen Ghiassy. All rights reserved.
//

#import "AFJSONRequestOperation.h"
#import "User.h"
#import "UserPhoto.h"

@implementation User

- (id)init
{
    self = [self initWithFirstName:@"Default First Name" lastName:@"Default Last Name" city:@"Default City" bio:@"Default Bio" ipAddress:@"Default IP Address" photo:[[UserPhoto alloc]init]];
    return self;
}

- (NSString *)getFullName
{
    return [NSString stringWithFormat:@"%@%@%@", self.firstName, @" ", self.lastName];
}

- (id)initWithFirstName:(NSString *)aFirstName lastName:(NSString *)aLastName city:(NSString *)aCity bio:(NSString *)aBio photo:(UserPhoto *)aPhoto
{
    self = [super init];
    
    if(self){
        self.firstName = aFirstName;
        self.lastName = aLastName;
        self.city = aCity;
        self.userPhoto = aPhoto;
        self.bio = aBio;
        
        //Send a Network Request for IP Address
        NSURL *url = [[NSURL alloc] initWithString:@"http://httpbin.org/ip"];
        NSURLRequest *request = [[NSURLRequest alloc] initWithURL:url];
        AFJSONRequestOperation *operation = [AFJSONRequestOperation
                                             JSONRequestOperationWithRequest:request
                                             success:^(NSURLRequest *request, NSHTTPURLResponse *response, id JSON) {
                                                 //Log successfull response
                                                 NSLog(@"IP Address Grabbed Successfully");
                                                 
                                                 //Set IP Address on Model
                                                 self.ipAddress = JSON[@"origin"];
                                                 
                                                 //Post Success Notifcation
                                                 [[NSNotificationCenter defaultCenter] postNotificationName:@"UserModelLoaded" object:nil];
                                             } failure:^(NSURLRequest *request, NSHTTPURLResponse *response, NSError *error, id JSON) {
                                                 NSLog(@"Network Request Error %@", error.localizedDescription);
                                             }];
        [operation start];
    }
    
    return self;
}

- (id)initWithFirstName:(NSString *)aFirstName lastName:(NSString *)aLastName city:(NSString *)aCity bio:(NSString *)aBio ipAddress:(NSString *)anIPAddress photo:(UserPhoto *)aPhoto
{
    self = [super init];
    
    if(self){
        self.firstName = aFirstName;
        self.lastName = aLastName;
        self.city = aCity;
        self.ipAddress = anIPAddress;
        self.userPhoto = aPhoto;
        self.bio = aBio;
    }
    
    return self;
}

@end